var kSystemOutputSourceType = "system output";
var kSystemEffectsSourceType = "effects output";
var kSystemInputSourceType = "system input";
var kApplicationSourceType = "application";

markup.push({
	OutputListItem: sourceListItemView({outputItem: true, showEQ: true, sourceType: kSystemOutputSourceType, isOutputType: true}),
	EffectsListItem: sourceListItemView({outputItem: true, showEQ: false, sourceType: kSystemEffectsSourceType, isOutputType: true}), // not selectable
	InputListItem: sourceListItemView({outputItem: true, showEQ: false, sourceType: kSystemInputSourceType, isOutputType: false}),
	AppSourceListItem: sourceListItemView({outputItem: false, showEQ: true, sourceType: kApplicationSourceType, isOutputType: true}) 
});

function sourceListItemView({outputItem, showEQ, sourceType, isOutputType}) {
	var normalHeight = 36;
	var volumeSliderMax = 1.0;
	var volumeSliderDetents = "0,1";
	var isSelectable = selectable || true;
	var topPadding = 7;
	var leftPadding = 10;
	var rightPadding = 10.5;
	var footerHeight = (sourceType == kSystemOutputSourceType || sourceType == kApplicationSourceType) ? 55 : 10;
	return {
		nsClass: "SoundSource.TCSourceView",  
		axIsIgnored: false,
		axTitleKeyPath: "axTitle",
		axHelpKeyPath: "axHelp",
		axRoleDescription: "Source List Item",
		axDescriptionKeyPath: "axDescription",
		multipleSelection: false,
		gxExpandOnMouseClick: false,
		selectable: true,
		gxDrawsSelected: true,
		gxDrawsFocused: false,
		gxLayoutSubviews: true,
		gxIntrinsicHeight: normalHeight,
		gxValueKeyPath: "",
		gxDragController: sourceType == kApplicationSourceType ? { "+" : "ListDragController" } : null, 
		gxForePainter: {
			nsClass: "SoundSource.TCAdvancedViewBackgroundPainter",
			gxEdgeInsets: "12.5,45.5,12.5,12.5",
			"pointWidth": 19,
			"pointHeight": 8, // Just high enough to not be visible when advanced section is hidden
			gxFrameColor: "name:controlFrame",
			gxFillColor: "name:lightMinty",
		}, 
		gxBackPainter: {
			nsClass: "GXRoundRectPainter",
			gxEdgeInsets: "0,0,0,0",
			gxCornerRadius: 0, // No corners so other views can't appear from below
			gxStrokeWidth: 2,
			gxFillColor: "name:background",
			"open" : { 
				gxCornerRadius: 10,
			},
			"selected" : {
				gxCornerRadius: 10,
				gxFillColor: "name:superLightMinty",
				gxFrameColor: "name:darkMinty",
			}, 
		}, 
		gxLayout: [
			"H:|-0-[self]-0-|",
			`V:|-${topPadding + 1}-[sourceIcon(20)]`,
			`V:|-${topPadding + 3}-[sourceName]`,
			"H:[sourceName(>=90)]-(>=0)-[volumeIndicator]-(>=0)-[volumeSlider][spacer(==volumeSliderReadout)]-6-[magicBoostButton(26)]-(>=0)-[showEffectsButton]&alignBaseline",
			"H:[showEffectsButton]-(-10)-[fxBadge]",
			"V:[showEffectsButton]-(-26)-[fxBadge]",
			`V:|-${topPadding-2}-[deviceSelectPopup(26)]`,
			`H:|-${leftPadding}-[sourceIcon(20.5)]-5-[sourceName]-(5)-[volumeIndicator]-0-[volumeSlider(145)]-(0)-[volumeSliderReadout(35)]`,
			"H:[volumeSlider]-(0)-[volumeSliderReadout]",
			"H:[sourceName]-(>=0)-[volumeSliderReadout]&alignBaseline",
			"H:[sourceDelete(==sourceIcon)]-(<=0)-[sourceIcon]&alignCenterY",
			"V:[sourceDelete(==sourceIcon)]-(<=0)-[sourceIcon]&alignCenterX",
			"H:[sourceDeleteForAX]-(<=0)-[sourceIcon]&alignCenterY",
			"V:[sourceDeleteForAX]-(<=0)-[sourceIcon]&alignCenterX",
			"H:[magicBoostButton]-8-[levelMetersEnabled]-11-[deviceSelectPopup(153.5)]&alignCenterY",
			`H:[deviceSelectPopup]-9-[showEffectsButton]-${rightPadding}-|`,
			"H:[deviceSelectPopup]-(<=-36)-[bluetoothSpinner(16)]",
			"V:|-10-[bluetoothSpinner(16)]",
			"H:[magicBoostButton]-10-[muteAlert]&alignBaseline",
			"H:[magicBoostButton]-10-[deviceAlert]&alignBaseline",
			"V:[levelMetersDisabled]-(<=0)-[levelMetersEnabled]&alignCenterX",
			"H:[levelMetersDisabled]-(<=0)-[levelMetersEnabled]&alignCenterY",
			"V:|-48@400-[customExpansionView]-(-4)-|"
		],
		gxChildViews: { 
			spacer: {
				nsClass: GXDrawView
			}, 
			sourceDelete: {
				"+": "deleteButton",
				gxLayerZPosition: 0,
				gxToolTipKeyPath: "deleteSourceToolTip",
				axIsIgnored: true,
				gxIgnoreNextKeyView: true,
			},
			sourceDeleteForAX: {
				nsClass: GXButtonView,
				gxBackPainter: {
					nsClass: "GXPainter",
					gxFillColor: null,
				},
				axIsIgnored: outputItem,
				gxIntrinsicHeight: 20,
				gxIntrinsicWidth: 20,
				axTitle: "Source Delete",
				gxValueKeyPath: "remove",
				gxIgnoreNextKeyView: true,
			},
			sourceIcon: {
				"+": "ImageView",
				gxValueKeyPath: "sourceIcon",
				gxShowSpeedSeconds: 0.2,
				gxHideSpeedSeconds: 0.2,
				gxLayerZPosition: 1,
				gxHideOnNilValue: true,
 				"gxImagePainter": {
					"+": "ImagePainter",
					gxTintColor: (sourceType != kApplicationSourceType) ? "name:fullGreen" : null,
					gxFillColor: "name:background",
					"selected" : {
						gxFillColor: "name:superLightMinty",
					},
				},
				axIsIgnored: true,
			},
			sourceName: {
				"+": "LabelView.left.size13",
				gxIntrinsicWidth: -1,
				gxValueKeyPath: "sourceName",
			}, 
			volumeIndicator: {
				nsClass: "GXVolumeIndicator",
				gxAnimateOnKey: "device.isConnectingBluetooth",
				gxBaselineOffset: 5,
				gxIntrinsicWidth: 18,
				gxIntrinsicHeight: 18,
				gxForePainter: {
					nsClass: "GXPainter",
					gxFillColor: "name:fontColor",
					"mixed" : { // Muted
						gxFillColor: "name:red"
					}
				},
				gxValueKeyPath: "volumeIndicator",
				axHelpKeyPath: "muteSourceToolTip",
				gxToolTipKeyPath: "muteSourceToolTip" 
			},
			volumeSlider: {
				"+": "SliderView",
				nsClass: "SoundSource.TCSliderView",  
				isMainUISlider: true,
				gxPlayEffectsOnMouseUp: true,	
				gxStylesKeyPath: "volumeSliderStyles",
				gxDetents: volumeSliderDetents,
				gxTrackMidRatio: 1.0,
				gxIgnoreDoubleClick: true,
				gxDefaultValue: 1.0,
				gxDisableOnNil: true,
				gxBaselineOffset: 5,
				gxEndGap: 10,
				gxReadoutTemplate: {
					"+": "SliderReadout.percentage",
					gxStylesKeyPath: "volumeReadoutStyles",
					gxForePainter : {
						"+" : "LabelFore.left.size11",
						gxFontColor: "name:volumeFont"
					},
					gxClickValue: 1.0,
					gxBaselineOffset: 6,
				},
				gxKeystrokeStepSize: 0.0652,
				gxLargeKeystrokeStepSize: 2.0,
				gxDetentPainter: "",
				gxRangeMin: 0,
				gxRangeMaxKeyPath: "volumeController.rangeMax",
				axFormatter: "AXVolumeSliderFormatter",
				axRoleDescription: "Volume Slider",
				gxValueKeyPath: "userSetVolume",
				gxReadoutKeyPath: "volumeController.volumeForReadout",
				gxToolTipKeyPath: "volumeToolTip",
			},
			magicBoostButton: {
				gxIntrinsicWidth: 25,
				gxIntrinsicHeight: 25,
				axCheckboxRole: true,
				gxBaselineOffset: 7,
				nsClass: "SoundSource.TCMagicBoostButton",
				gxShowOnKey: "showMagicBoost",
				gxForePainter: {
					"+": "ImagePainter.icon-boost",
				},
				gxTitle: "",
				gxDisableOnNilValue: true,
				gxValueKeyPath: "userSetBoost",
				axTitle: "Magic Boost",
				gxToolTip: "Enable Magic Boost",
				gxPressedToolTip: "Disable Magic Boost",
				magicBoostGrayBack: "name:controlBackFill",
				magicBoostLightGreen: "rgba:62,186,49,100",
				magicBoostPressed: "rgba:62,186,49,100",
				magicBoostDarkGreen: "name:fullGreen",
				magicBoostBorder: "name:controlFrame",
				magicBoostBlack: "name:black",
				magicBoostWhite: "name:white",
				
			},
			muteAlert: {
				"+" : "AlertButton",
				gxValueKeyPath: "showMuteAlert",
				gxShowOnKey: "showMuteAlert",
			},
			deviceAlert: {
				"+" : "AlertButton",
				gxValueKeyPath: "showDeviceAlert",
				gxShowOnKey: "showDeviceAlert",
			}, 
			levelMetersEnabled: {
				"+": "levelMeterDisplay",
				gxHideOnKey: "muted",
				"gxPeakValueKeyPath": "levelMeter.peakStereoMax",
				"gxClipValueKeyPath": "levelMeter.clipStereoMax",
			},
			levelMetersDisabled: {
				"+": "levelMeterDisplay.disabled",
				gxShowOnKey: "muted",
				"gxPeakValueKeyPath": "levelMeter.peakStereoMax",
				"gxClipValueKeyPath": "levelMeter.clipStereoMax",
			},
			deviceSelectPopup: {
				"+": "PopupMenuView",
				nsClass: "SoundSource.TCAudioDevicePopupButton",
				gxForePainter: {
					"+": "FlatButtonFore.size12.left",
					gxEdgeInsets: "6,0,20,0",
				}, 
				gxValueKeyPath: "displayDevice",
				gxEnableOnKey: "deviceSelectorEnabled",
				axHelpKeyPath: "deviceSelectHelp",
				gxToolTipKeyPath: "deviceSelectToolTop",
				gxLabelText: null,
			},
			bluetoothSpinner: {
				nsClass: "GXDrawView",
				gxValueKeyPath: "",
				gxChildViews: {
					"spinner" : {
						nsClass: "GXSpinnerView",
						gxLayout: [
							"H:|-0-[self]-0-|",
							"V:|-0-[self]-0-|"
						],
						gxValueKeyPath: "",
						gxAnimateOnKey: "device.connectingBluetooth",
						gxStepSize: 30, // Rotate 30 degree increments
						gxSpinAngleScale: 640, // Match speed of system spinner
						gxFrameRect: "0,0,16,16",
						gxShowOnKey: "device.connectingBluetooth",
						gxSpinLayer: {
							nsClass: "GXDrawLayer",
							gxForePainter: {
								"+" : "ImagePainter.system_spinner",
								gxTintColor: "name:btSpinner",
							},
							gxFrameRect: "0,0,16,16",
							gxAnchorPoint: "0.5, 0.5",	// spin around center
							gxOpacity: 0,	// start invisible
						},
					}
				}
			},
			showEffectsButton: {
				"+" : "DisclosureButton", 
				gxValueKeyPath: "userToggleAdvancedView",
				gxDisableOnKey: "toggleAdvancedViewDisabled",
				gxToolTip: "Show advanced section",
				gxPressedToolTip: "Hide advanced section",
			},
			fxBadge : {
				nsClass: GXDrawView,
				gxIntrinsicWidth: 14,
				gxIntrinsicHeight: 9,
				gxValueKeyPath: "",
				gxShowOnKey: "advancedEffected",
				gxBackPainter: {
					"+" : "ImagePainter.fx-badge",
				},
				gxLayerZPosition: 1,
			},
			customExpansionView: {
				nsClass: "GXDrawView",
				gxValueKeyPath: "",
				gxHideSpeedSeconds:0.3,
				gxShowOnKey: "showEffectsSection",
				gxLayout: [
					"H:|-0-[self]-5-|",
					`V:|-0@300-[effectsSectionHeader]-0-[div1(1)]-6-[effectsList]-0-[footer]-0-|`,
				],
				gxChildViews: {
					effectsSectionHeader: effectsSectionHeader({ showSampleRate: outputItem, showBalance:  sourceType == kSystemOutputSourceType }),
					"div1" : {
						"+" : "PanelDivider",
						gxBackPainter: sourceType == kSystemOutputSourceType ? "PanelDividerPainter" : null,
						gxLayout : ["H:|-22-[self]-17-|"],
					},
					"effectsList": {
						nsClass: "GXListView",
						multipleSelection: false,
						axIsIgnored: true,
						gxShowSpeedSeconds: 0.1,
						gxHideSpeedSeconds: 0.1,
						listTopHeight: 0,
						gxLayout: [
							"H:|-0-[self]-0-|",
						],
					},
					footer: {
						nsClass: GXDrawView,
						gxLayout: [
							"H:|-0-[self]-20-|",
							`V:[self(${footerHeight})]`,
							"V:[addEffect(24)]-27-|",
							"H:|-23-[addEffect(100)]-(>=0)-[latencyWarning]-0-|&alignCenterY"
						],
						gxIgnoreMouseClick: true,
						gxIntrinsicHeight: footerHeight,
						gxChildViews: {
							"addEffect": {
								"+": "FlatButtonPopup.size12.green.down",
								gxLayout:[],
								gxResetItemsOnOpen: false, 
								gxForePainter: {
									"+": "FlatButtonFore",
									gxEdgeInsets: "-10,-1,10,0"
								},
								gxValueKeyPath: "customEffects.addEffect",
								gxShowOnKey: "hasEffectsSection",
								gxMenuItemsKeyPath: "customEffects.effectsMenuItems",
								axTitle: "Add Effect",
								gxPullsDown: true,
								gxToolTipKeyPath: "addEffectHelp",
							},
							"latencyWarning": {
								"+" : "LabelView.size12.right.fontColor",
								gxValueKeyPath: "",
								gxShowOnKey: "customEffects.showLatencyWarning",
								gxLayout: [
									   "V:[self(24)]"
								],
								gxDefaultValue: "\u{26A0}\u{FE0F} Significant delay will be audible with this effects configuration."
							}
						}
					},
				}
			},
		},
	}
};
 

function effectsSectionHeader({showSampleRate, showBalance}) {
    var intrinsicHeight = (showSampleRate || showBalance) ? 55 : 12; // Affects the plugin list vertical position
	return {
		nsClass: "GXDrawView",
		gxValueKeyPath: "",
		gxIntrinsicHeight: intrinsicHeight, // Important for autolayout calculations we do in code
		axIsIgnored: true,
		axTitle: "Advanced Settings",
		gxLayout: [
			   "H:|-0-[self]-0-|",
			   `V:[self(${intrinsicHeight})]`,
			   "V:|-0-[balanceSection]-0-|",
			   "H:|-11-[balanceSection(270)]",
			   "H:[balanceLabel]-(>=0)-[sampleRatePopup(155)]-16-|&alignBaseline",
			   "V:[sampleRatePopupLabel(19)]",
			   "V:[self]-(<=0)-[centerV]&alignCenterX",
		],
		gxChildViews: {
			"centerV" : { nsClass: GXDrawView },
			"balanceSection": {
				nsClass: "GXDrawView",
				gxBaselineOffset: 10,
				gxIntrinsicHeight: -1,
				gxShowOnKey: "showPanControl",
				gxValueKeyPath: "",
				gxLayout: [
					"V:|-20-[balanceLabel]",
					"H:[balanceLabel]-5-[panSliderLabelLeft]-0-[panSlider(144)]-2-[panSliderLabelRight]&alignBaseline",
				],
				gxChildViews: {
					panSlider: {
						"+": "SliderPointy",
						gxIntrinsicHeight: 30,
						isMainUISlider: true,
						gxAnimatesSliderForModelUpdates: true,
						gxDetents: "-1, 0, 1",
						gxTrackPainter: {
							"+": "SliderTrack",
							"on": {
								gxCornerRadii: "1, 1, 1, 1",
								gxEdgeInsets: "0,0,0,0",     // on track is inset on left
								gxFrameColor: "name:fullGreen",
								gxFillColor: "name:fullGreen"
							},
						},
						gxTrackMidRatio: 0.0,
						gxSliderTrackStyling: 1,
						gxKeystrokeStepSize: 0.01,
 						gxRangeMax: 1,
						gxRangeMin: -1,
						gxLayout: [
							"H:|-0-[selfLabel(80)]-5-[self]",
						],
						axFormatter: "AXBalanceSliderFormatter",
						gxValueKeyPath: "balance",
						gxReadoutKeyPath: "balance",
						gxLabelText: null,
						gxShowOnKey: "showPanControl", // Important for removing from searchable responders
						axTitle: "Balance",
						gxToolTip: "Balance all audio being sent to the system output",
					},
					balanceLabel: {
						"+": "LabelView.size13.right",
						gxIntrinsicHeight: 25,
						gxBaselineOffset: 5,
						gxDefaultValue: "Balance:",
						axIsIgnored: true,
					},
					panSliderLabelLeft: {
						"+": "LabelView.size13.right",
						gxIntrinsicHeight: 25,
						gxBaselineOffset: 5,
						gxDefaultValue: "L",
						axIsIgnored: true,
					},
					panSliderLabelRight: {
						"+": "LabelView.size13.left",
						gxIntrinsicHeight: 25,
						gxBaselineOffset: 5,
						gxDefaultValue: "R",
						axIsIgnored: true,
					},
				}
			},
			"sampleRatePopup" : {
				"+" : "PopupMenuView",  
				gxForePainter: {
					"+": "FlatButtonFore.size13.left",
					gxMonospacedDigits: false,
					gxEdgeInsets: "10,0,0,0",
				},
				gxBaselineOffset: 7,
				gxLabelText: "Sample Rate:",
				gxMenuItemsKeyPath: "sampleRateMenuItems",
				gxValueKeyPath: "setSampleRate",
				gxHideOnNilValue: true,
				axTitle: "Sample Rate Selection",
				gxToolTipKeyPath: "sampleRateToolTip",
			},
		},
	};
};

